// BookInfo.cpp: implementation of the CBookInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BookInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBookInfo::CBookInfo()
{
    iBookCode = 0;
	strName = "";
	strAuthor = "";
	strPublisher = "";
	iPublishYear = 2000;
	iBookCount = 30;
	iRemainCount = 30;
}

CBookInfo::~CBookInfo()
{

}

// ѧŵõϢ
void CBookInfo::GetInfo(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM BookInfo WHERE BookCode = " + paraId;

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ظеֵ
	if (m_pRecordset->adoEOF)
		CBookInfo();
	else
	{
		iBookCode = atol(paraId);
		strName = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name");
		strAuthor = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Author");
		strPublisher = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Publisher");

		iPublishYear = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("PublishYear"));		
		iBookCount = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BookCount"));
		iRemainCount = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("RemainCount"));
	}

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

//ȡָѧ
CString CBookInfo::GetName(CString paraId)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT Name FROM BookInfo WHERE BookCode = " + paraId;

	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	if (m_pRecordset->adoEOF)
		return "";
	else
		return (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name");

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// 
void CBookInfo::SqlInsert()
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//INSERT
	CString strBookCode;
	strBookCode.Format("%ld", iBookCode);
	CString strublishYear;
	strublishYear.Format("%ld", iPublishYear);
	CString strBookCount;
	strBookCount.Format("%ld", iBookCount);
	CString strRemainCount;
	strRemainCount.Format("%ld", iRemainCount);
	_bstr_t vSQL;
	
    vSQL = "INSERT INTO BookInfo (BookCode, Name, Author, Publisher, PublishYear, BookCount, RemainCount)"
		" VALUES ('" + strBookCode + "', '" + strName + "', '" + strAuthor + "', '" + strPublisher
		+ "', '" + strublishYear + "', '" + strBookCount + "', '" + strRemainCount +"')";
	//ִINSERT
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ޸Ĳ
void CBookInfo::SqlUpdate(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//UPDATE
	_bstr_t vSQL;
	
	CString strublishYear;
	strublishYear.Format("%ld", iPublishYear);
	CString strBookCount;
	strBookCount.Format("%ld", iBookCount);
	CString strRemainCount;
	strRemainCount.Format("%ld", iRemainCount);
	vSQL = "UPDATE BookInfo SET Name = '" + strName + "', Author = '" + strAuthor
		+ "', Publisher = '" + strPublisher + "', PublishYear = '" + strublishYear + "', BookCount = '" + strBookCount
		+ "' , RemainCount = '" + strRemainCount +"' WHERE BookCode = " + paraId;

	//ִUPDATE
	m_AdoConn.ExecuteSQL(vSQL);

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ɾָѧϢ
void CBookInfo::SqlDelete(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//DELETE
	_bstr_t vSQL;
	vSQL = "DELETE FROM BookInfo WHERE BookCode = " + paraId;

	//ִDELETE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}//*/