// BorrowBookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BorrowBookDlg.h"
#include "BorrowBookInfo.h"
#include "BookInfo.h"
#include "Student.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBorrowBookDlg dialog


CBorrowBookDlg::CBorrowBookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBorrowBookDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBorrowBookDlg)
	m_BookCode = _T("");
	m_BorrowDate = _T("");
	m_StuNum = _T("");
	//}}AFX_DATA_INIT
}


void CBorrowBookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBorrowBookDlg)
	DDX_Text(pDX, IDC_EDIT_BOOK_CODE, m_BookCode);
	DDX_Text(pDX, IDC_EDIT_BORROW_DATE, m_BorrowDate);
	DDX_Text(pDX, IDC_EDIT_STU_NUM, m_StuNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBorrowBookDlg, CDialog)
	//{{AFX_MSG_MAP(CBorrowBookDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBorrowBookDlg message handlers

void CBorrowBookDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if(m_BookCode == "")
	{
		MessageBox("ͼ벻Ϊգд!");
		return;
	}
	if(m_StuNum == "")
	{
		MessageBox("ѧѧŲΪգд!");
		return;
	}
	//---------------
	CBookInfo BI;
	//BI.iBookCode = atol(m_BookCode);
	if("" == BI.GetName(m_BookCode))
	{
		MessageBox("ͼ벻ڣȷ!");
		return;
	}
	CStudent st;
	//st.iStuNum = atol(m_StuNum);
	if("" == st.GetName(m_StuNum))
	{
		MessageBox("ѧѧŲڣȷ!");
		return;
	}

	st.GetInfo(m_StuNum);
	st.iBorrowBookCount++;
	st.SqlUpdate(m_StuNum);

	BI.GetInfo(m_BookCode);
	if(BI.iRemainCount <= 0)
	{
		MessageBox("Ѿû˰¼!");
		return;
	}
	BI.iRemainCount--;
	BI.SqlUpdate(m_BookCode);
	//----------------
    CBorrowBookInfo cur;
	cur.iBookCode = atol(m_BookCode);
	cur.iStuNum = atol(m_StuNum);
	cur.strBorrowDate = m_BorrowDate;
	cur.SqlInsert();
	CDialog::OnOK();
}

BOOL CBorrowBookDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();	
	// TODO: Add extra initialization here
	GetDlgItem(IDC_EDIT_BORROW_DATE)->EnableWindow(FALSE);
	CTime CurTime = CTime::GetCurrentTime();
	m_BorrowDate = CurTime.Format("%Y-%m-%d");
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
