// BorrowBookInfo.cpp: implementation of the CBorrowBookInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BorrowBookInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBorrowBookInfo::CBorrowBookInfo()
{
    iBorrowId = 0;
	iBookCode = 0;
	iStuNum = 1;
	strBorrowDate = "2000.01.01";
}

CBorrowBookInfo::~CBorrowBookInfo()
{

}

// ݿ
void CBorrowBookInfo::GetInfo(CString paraId)		// ݱŵõϢ
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM BorrowBookInfo WHERE BorrowId = " + paraId;

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ظеֵ
	if (m_pRecordset->adoEOF)
		CBorrowBookInfo();
	else
	{
		iBorrowId = atol(paraId);
		iBookCode = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BookCode"));		
		iStuNum = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("StuId"));
		strBorrowDate = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BorrowDate");
	}

	//Ͽݿ
	m_AdoConn.ExitConnect();
}
LONG CBorrowBookInfo::GetBorrowId(CString BookCode, CString StuNum)		// ѧѧŷر
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM BorrowBookInfo WHERE BookCode = '" + BookCode + "' AND StuId = '" + StuNum + "'";

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ظеֵ
	if (m_pRecordset->adoEOF)
		return -1;
	else
	{
		iBorrowId = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BorrowId"));		
	}

	//Ͽݿ
	m_AdoConn.ExitConnect();
	return iBorrowId;
}
CString CBorrowBookInfo::GetCode(CString paraId)	// ָıŷͼ
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT Name FROM BorrowBookInfo WHERE BorrowId = " + paraId;

	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	if (m_pRecordset->adoEOF)
		return "";
	else
		return (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BookCode");

	//Ͽݿ
	m_AdoConn.ExitConnect();
}
void CBorrowBookInfo::SqlInsert()					// 
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//INSERT
	CString strBorrowId;
	strBorrowId.Format("%ld", iBorrowId);
	CString strBookCode;
	strBookCode.Format("%ld", iBookCode);
	CString strStuNum;
	strStuNum.Format("%ld", iStuNum);

	_bstr_t vSQL;
	
    vSQL = "INSERT INTO BorrowBookInfo (BookCode, StuId, BorrowDate)"
		" VALUES ('" + strBookCode + "', '" + strStuNum + "', '" + strBorrowDate
		+ "' )";
	//ִINSERT
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}
void CBorrowBookInfo::SqlUpdate(CString paraId)		// 
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//UPDATE
	_bstr_t vSQL;
	
	CString strBookCode;
	strBookCode.Format("%ld", iBookCode);
	CString strStuNum;
	strStuNum.Format("%ld", iStuNum);
	vSQL = "UPDATE BorrowBookInfo SET BookCode = '" + strBookCode + "', StuId = '" + strStuNum
		+ "', BorrowDate = '" + strBorrowDate + "' WHERE BorrowId = " + paraId;

	//ִUPDATE
	m_AdoConn.ExecuteSQL(vSQL);

	//Ͽݿ
	m_AdoConn.ExitConnect();
}
void CBorrowBookInfo::SqlDelete(CString paraId)		// ɾ
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//DELETE
	_bstr_t vSQL;
	vSQL = "DELETE FROM BorrowBookInfo WHERE BorrowId = " + paraId;

	//ִDELETE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}