// BorrowBookInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BorrowBookInfoDlg.h"
#include "COMDEF.H"
#include "Columns.h"
#include "Column.h"
#include "_Recordset.h"
#include "BorrowBookDlg.h"
#include "BorrowBookInfo.h"
#include "BookInfo.h"
#include "Student.h"
#include "RestorBookDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBorrowBookInfoDlg dialog
extern CUserInfo curUser;

CBorrowBookInfoDlg::CBorrowBookInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBorrowBookInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBorrowBookInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBorrowBookInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBorrowBookInfoDlg)
	DDX_Control(pDX, IDC_ADODC1, m_Adodc);
	DDX_Control(pDX, IDC_DATAGRID1, m_DataGrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBorrowBookInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CBorrowBookInfoDlg)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	ON_BN_CLICKED(IDC_DEL_RESTORE, OnDelRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBorrowBookInfoDlg message handlers
//Ӽ¼
void CBorrowBookInfoDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CBorrowBookDlg dlg;
	dlg.DoModal();
	RefreshData();
}
//ע¼
void CBorrowBookInfoDlg::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString strBorrowId = m_DataGrid.GetItem(0);
	CBorrowBookInfo BBI;
	BBI.SqlDelete(strBorrowId);
	//----------------------------
	CBookInfo BI;
	BI.GetInfo(m_DataGrid.GetItem(1));
	BI.iRemainCount++;
	BI.SqlUpdate(m_DataGrid.GetItem(1));

	CStudent st;
	st.GetInfo(m_DataGrid.GetItem(3));
	st.iBorrowBookCount--;
	st.SqlUpdate(m_DataGrid.GetItem(3));
	//----------------------------
	RefreshData();
}

BOOL CBorrowBookInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Ȩ޿ƣǹԱӡ޸ĺɾťû
	if (curUser.UserType != 1)
	{
		GetDlgItem(IDC_ADD_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MODI_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEL_BUTTON)->EnableWindow(FALSE);
	}
	RefreshData();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBorrowBookInfoDlg::RefreshData()
{
	UpdateData(TRUE);

	// SELECT
	CString cSource = "SELECT b.BorrowId, b.BookCode AS ͼ, bb.Name AS ͼ, "
		"b.StuId AS ѧѧ, s.Name AS ѧ, b.BorrowDate AS ʱ FROM BorrowBookInfo b,"
		"Student s, BookInfo bb WHERE b.BookCode = bb.BookCode AND s.StuId = b.StuId";

	//cSource = "SELECT b.BorrowId, b.BookCode, bb.Name, b.StuId, s.Name, b.BorrowDate FROM BorrowBookInfo b, Student s, BookInfo bb WHERE b.BookCode = bb.BookCode, s.StuId = b.StuId";
	//ˢADO Dataؼļ¼Դ
	m_Adodc.SetRecordSource(cSource);
	m_Adodc.Refresh();
	
	//п
	_variant_t vIndex;
	vIndex = long(0);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(0);
	vIndex = long(1);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(2);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(90);
	vIndex = long(3);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(4);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(5);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(60);
}
//ѯע¼
void CBorrowBookInfoDlg::OnDelRestore() 
{
	// TODO: Add your control notification handler code here
	CRestorBookDlg dlg;
	dlg.DoModal();
	RefreshData();
}
