// DepInfo.cpp: implementation of the CDepInfo class

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "DepInfo.h"
#include "ADOConn.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDepInfo::CDepInfo()
{
	DepId = 0;
	DepName = "";
	Describes = "";
	UID = 0;
}

CDepInfo::~CDepInfo()
{

}

// ȡԺϵšƺϼԺϵŵϢCStringArray
void CDepInfo::LoadDep()
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM DepInfo ORDER BY UID";
	
	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ʼ
	a_DepName.RemoveAll();
	a_DepId.RemoveAll();
	a_UID.RemoveAll();

	//ִSELECT
	while (m_pRecordset->adoEOF == 0)
	{
		a_DepId.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepId"));
		a_DepName.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepName"));
		a_UID.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("UID"));

		m_pRecordset->MoveNext();
	}

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// жָԺϵǷ
int CDepInfo::HaveName(CString paraName)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM DepInfo WHERE DepName = '" + paraName + "'";

	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return -1;
	else
		return 1;

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// жָԺϵǷ¼Ժϵɾ
int CDepInfo::HaveSon(CString paraId)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM DepInfo WHERE UID = " + paraId;
	
	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return -1;
	else
		return 1;

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// жָԺϵǷרҵɾ
int CDepInfo::HaveSpeciality(CString paraId)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Speciality WHERE DepId = " + paraId;
	
	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return -1;
	else
		return 1;

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

//ԺϵŶȡֵֶ
void CDepInfo::GetInfo(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM DepInfo WHERE DepId = " + paraId;

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	
	//ظеֵ
	if (m_pRecordset->adoEOF)
		CDepInfo();
	else
	{
		DepId = atol(paraId);
		DepName = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepName");
		Describes = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Describes");
		UID = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("UID"));
	}
	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// 
long CDepInfo::SqlInsert()
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//INSERT
	CString strUID;
	strUID.Format("%d", UID);

	_bstr_t vSQL;
	vSQL = "INSERT INTO DepInfo (DepName, Describes, UID) VALUES('" 
		+ DepName + "','" + Describes + "'," + strUID + ")";
	
	//ִINSERT
	m_AdoConn.ExecuteSQL(vSQL);	

	//ȡ
	long lDepId;
	vSQL = "SELECT MAX(DepId) AS MaxId FROM DepInfo";	

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ظеֵ
	if (m_pRecordset->adoEOF)
		lDepId = 0;
	else
		lDepId = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("MaxId"));

	//Ͽݿ
	m_AdoConn.ExitConnect();

	return lDepId;
}

// 
void CDepInfo::SqlUpdate(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//UPDATE
	_bstr_t vSQL;
	vSQL = "UPDATE DepInfo SET DepName = '" + DepName 
		//+ "', Describes = '" + Describes + "' WHERE DepId = " + paraId;
    	+ "', Describes = '" + Describes + "' WHERE DepId = '" + paraId +"' ";

	//ִUPDATE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ɾ
void CDepInfo::SqlDelete(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//DELETE
	_bstr_t vSQL;
	vSQL = "DELETE FROM DepInfo WHERE DepId = " + paraId;

	//ִDELETE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}