// DepManDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "DepManDlg.h"
#include "DepEditDlg.h"
#include "DepInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUserInfo curUser;

/////////////////////////////////////////////////////////////////////////////
// CDepManDlg dialog


CDepManDlg::CDepManDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDepManDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDepManDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDepManDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDepManDlg)
	DDX_Control(pDX, IDC_TREE1, m_tree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDepManDlg, CDialog)
	//{{AFX_MSG_MAP(CDepManDlg)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_MODI_BUTTON, OnModiButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDepManDlg message handlers

BOOL CDepManDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Ȩ޿ƣǹԱӡ޸ĺɾťû
	if (curUser.UserType != 1)
	{
		GetDlgItem(IDC_ADD_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MODI_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEL_BUTTON)->EnableWindow(FALSE);
	}
	//װԺϵϢ
	dep.LoadDep();
	
	//Ӹڵ
	m_treeImageList.Create(16,16,FALSE,1,0);  //CImageListؼ

	//װICONԴ
	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON1));
	m_treeImageList.Add(hIcon);  //ICONԴӵCImageListؼ

	//CImageListؼTreeؼ	
	m_tree.SetImageList(&m_treeImageList, LVSIL_NORMAL);
	m_root = m_tree.InsertItem("ԺϵϢ");  //Ӹڵ

	//AddtoTree() ԺϵϢӵTreeؼ	
	AddtoTree(m_root, 0);
	m_tree.Expand(m_root, TVE_EXPAND); //չڵ

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDepManDlg::OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CDepManDlg::AddtoTree(HTREEITEM m_node, long UpperId)
{
	//ʹõݹ鷽ԺϵӵTreeViewؼ
	long i;
	HTREEITEM m_child;
	//ηdepеԺϵ飬ļ¼ӵTreeؼ
	for(i=0; i<dep.a_UID.GetSize(); i++)
	{
		if (UpperId == atoi(dep.a_UID.GetAt(i)))
		{
			m_child = m_tree.InsertItem(dep.a_DepName.GetAt(i), m_node);
			m_tree.SetItemData(m_child, atol(dep.a_DepId.GetAt(i)));
			AddtoTree(m_child, atol(dep.a_DepId.GetAt(i)));
		}
	}
}

// Ӱť
void CDepManDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	HTREEITEM node;  //ڱ浱ǰѡĽڵ
	node = m_tree.GetSelectedItem();  //ȡõǰѡĽڵ

	// ڵֻ
	if(m_tree.GetItemData(node) != 0)		// Ǹڵ
	{
		if(m_tree.GetItemData(m_tree.GetParentItem(node)) != 0)
		{
			MessageBox("ڴ˼ԺϵԺϵ");
			return;
		}
	}

	CDepEditDlg dlg;
	//ñ༭Իбֵ
	dlg.m_Upper = m_tree.GetItemText(node);
	dlg.UpperId = m_tree.GetItemData(node);
	dlg.DepId = 0;  //ʾ¼

	//ڱ༭ԻеȷťTreeView½ڵ
	if(dlg.DoModal() == IDOK)
	{
		HTREEITEM child;  //ʾ½ڵ㣬nodeӽڵ
		child = m_tree.InsertItem(dlg.m_DepName, node);  //ڵ
		m_tree.SetItemData(child, dlg.DepId);  //½ڵֵ
		m_tree.Expand(node, TVE_EXPAND); //չnodeڵ
	}
}

// ޸İť
void CDepManDlg::OnModiButton() 
{
	// TODO: Add your control notification handler code here
	HTREEITEM node;  //ڱ浱ǰڵ
	node = m_tree.GetSelectedItem(); //ȡõǰڵֵ
	if (m_tree.GetItemData(node) == 0)  //޸ĸڵ
	{
		MessageBox("޸Ĵ");
		return;
	}
	HTREEITEM parent;	//ȡڵ
	parent = m_tree.GetParentItem(node);

	CDepEditDlg dlg;
	//ñ༭Իбֵ
	dlg.m_Upper = m_tree.GetItemText(parent);
	dlg.UpperId = m_tree.GetItemData(parent);
	dlg.DepId = m_tree.GetItemData(node);
	dlg.DepName = m_tree.GetItemText(node);
	dlg.m_DepName = m_tree.GetItemText(node);
	// ȡǰԺϵϢ, ȡԺϵ
	CDepInfo dep;
	CString cId;
	cId.Format("%d", dlg.DepId);
	dep.GetInfo(cId);
	dlg.m_Describe = dep.Describes;

	//ڱ༭ԻеȷťTreeView޸ĽڵϢ
	if(dlg.DoModal() == IDOK)
	{
		m_tree.SetItemText(node, dlg.m_DepName);  //õǰڵʾ
		m_tree.Expand(node, TVE_EXPAND);  //չǰڵ
	}	
}

// ɾť
void CDepManDlg::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	HTREEITEM node;  //ڱ浱ǰڵ
	node = m_tree.GetSelectedItem();  //ȡõǰڵ
	if (m_tree.GetItemData(node) == 0) //ɾڵ
	{
		MessageBox("ɾ");
		return;
	}

	//ȡõǰڵֵתΪCString
	CString cDepId;
	cDepId.Format("%d", m_tree.GetItemData(node));
	if (dep.HaveSon(cDepId) == 1)
	{
		MessageBox("Ժϵ¼Ժϵɾ");
		return;
	}
	if (dep.HaveSpeciality(cDepId) == 1)
	{
		MessageBox("Ժϵרҵɾ");
		return;
	}

	//ԻҪûȷǷɾûǡťɾ
	if (MessageBox("ǷɾǰԺϵ", "ȷ", MB_YESNO) == IDYES)
	{
		dep.SqlDelete(cDepId);  //ɾDepInfoеָ¼
		m_tree.DeleteItem(node);  //ɾTreeؼеĵǰڵ
	}
}
