// LibraryMagSysDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "LibraryMagSysDlg.h"
#include "LoginDlg.h"
#include "UserManDlg.h"
#include "PasswdDlg.h"
#include "DepManDlg.h"
#include "SpecialityMan.h"
#include "StuManDlg.h"
#include "BookManDlg.h"
#include "BorrowBookInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUserInfo curUser;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLibraryMagSysDlg dialog

CLibraryMagSysDlg::CLibraryMagSysDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLibraryMagSysDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLibraryMagSysDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLibraryMagSysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLibraryMagSysDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLibraryMagSysDlg, CDialog)
	//{{AFX_MSG_MAP(CLibraryMagSysDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDR_EXIT, OnExit)
	ON_COMMAND(IDR_USER, OnUser)
	ON_COMMAND(IDR_PASSWD, OnPasswd)
	ON_COMMAND(IDR_DEP, OnDep)
	ON_COMMAND(IDR_SPECIALITY, OnSpeciality)
	ON_COMMAND(IDR_STUDENT, OnStudent)
	ON_COMMAND(ID_BOOK_MANGEMENT, OnBookMangement)
	ON_COMMAND(ID_BORROW_RESTORE, OnBorrowRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLibraryMagSysDlg message handlers

BOOL CLibraryMagSysDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CLoginDlg dlg;  //½
	if (dlg.DoModal() != IDOK)
		OnOK();
	else
		//ȡûϢcurUser
		curUser.GetInfo(dlg.m_User);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLibraryMagSysDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLibraryMagSysDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLibraryMagSysDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//˳ϵͳ
void CLibraryMagSysDlg::OnExit() 
{
	// TODO: Add your command handler code here
	OnOK();
}
//û
void CLibraryMagSysDlg::OnUser() 
{
	// TODO: Add your command handler code here
	if(curUser.UserType != 1)
	{
		MessageBox("ûȨ޴򿪴˶Ի");
		return;
	}
	CUserManDlg dlg;
	dlg.DoModal();
}
//޸
void CLibraryMagSysDlg::OnPasswd() 
{
	// TODO: Add your command handler code here
	CPasswdDlg dlg;
	dlg.m_user = curUser.UserName;
	dlg.DoModal();
}
//ԺϵϢ
void CLibraryMagSysDlg::OnDep() 
{
	// TODO: Add your command handler code here
	CDepManDlg dlg;
	dlg.DoModal();
}
//רҵϢ
void CLibraryMagSysDlg::OnSpeciality() 
{
	// TODO: Add your command handler code here
	CSpecialityMan dlg;
	dlg.DoModal();
}
//ѧϢ
void CLibraryMagSysDlg::OnStudent() 
{
	// TODO: Add your command handler code here
	CStuManDlg dlg;
	dlg.DoModal();
}
//ͼϢ
void CLibraryMagSysDlg::OnBookMangement() 
{
	// TODO: Add your command handler code here
	CBookManDlg dlg;
	dlg.DoModal();
}
//ͼ黹
void CLibraryMagSysDlg::OnBorrowRestore() 
{
	// TODO: Add your command handler code here
	CBorrowBookInfoDlg dlg;
	dlg.DoModal();
}
