// Speciality.cpp: implementation of the CSpeciality class

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "Speciality.h"
#include "ADOConn.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSpeciality::CSpeciality()
{
	SpeId = 0;
	Name = "";
	DepId = 0;
	Describes = "";
}

CSpeciality::~CSpeciality()
{

}

// רҵϢ
void CSpeciality::LoadSpe()
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();
	
	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Speciality ORDER BY SpeId";
	
	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	
	//ʼ
	a_SpeId.RemoveAll();
	a_Name.RemoveAll();
	a_DepId.RemoveAll();
	
	//ִSELECT
	while (m_pRecordset->adoEOF == 0)
	{
		a_SpeId.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("SpeId"));
		a_Name.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name"));
		a_DepId.Add((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepId"));
		
		m_pRecordset->MoveNext();
	}
	
	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// жָרҵǷ
int CSpeciality::HaveName(CString paraName)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Speciality WHERE Name = '" + paraName + "'";

	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return -1;
	else
		return 1;

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// жָԺϵǷѧɾ
int CSpeciality::HaveStu(CString paraId)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Student WHERE SpeId = " + paraId;
	
	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return -1;
	else
		return 1;

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

//רҵŶȡֵֶ
void CSpeciality::GetInfo(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Speciality WHERE SpeId = " + paraId;

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	
	//ظеֵ
	if (m_pRecordset->adoEOF)
		CSpeciality();
	else
	{
		SpeId = atol(paraId);
		Name = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name");
		DepId = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepId"));
		Describes = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Describes");
	}
	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// 
void CSpeciality::SqlInsert()
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//INSERT
	CString strDepId;
	strDepId.Format("%d", DepId);

	_bstr_t vSQL;
	vSQL = "INSERT INTO Speciality (Name, DepId, Describes) VALUES('" 
		+ Name + "', " + strDepId + ", '" + Describes + "')";
	
	//ִINSERT
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// 
void CSpeciality::SqlUpdate(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//UPDATE
	_bstr_t vSQL;
	vSQL = "UPDATE Speciality SET Name = '" + Name 
		+ "', Describes = '" + Describes + "' WHERE SpeId = " + paraId;

	//ִUPDATE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ɾ
void CSpeciality::SqlDelete(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//DELETE
	_bstr_t vSQL;
	vSQL = "DELETE FROM Speciality WHERE SpeId = " + paraId;

	//ִDELETE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}
CString CSpeciality::GetDepName(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT (d1.DepName+'-'+d.DepName) AS dName"
		" FROM Speciality s,DepInfo d,DepInfo d1"
		" WHERE s.DepId=d.DepId And d.UID=d1.DepId And s.SpeId = " + paraId;
	
	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	if (m_pRecordset->adoEOF)
		return "";
	else
		return (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("dName");

	//Ͽݿ
	m_AdoConn.ExitConnect();
}