// SpecialityMan.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "SpecialityMan.h"
#include "SpecialEditDlg.h"
#include "Speciality.h"
#include "DepInfo.h"
#include "UserInfo.h"
#include "COMDEF.H"
#include "Columns.h"
#include "Column.h"
#include "_Recordset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUserInfo curUser;

/////////////////////////////////////////////////////////////////////////////
// CSpecialityMan dialog


CSpecialityMan::CSpecialityMan(CWnd* pParent /*=NULL*/)
	: CDialog(CSpecialityMan::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpecialityMan)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSpecialityMan::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpecialityMan)
	DDX_Control(pDX, IDC_TREE1, m_tree);
	DDX_Control(pDX, IDC_ADODC1, m_Adodc);
	DDX_Control(pDX, IDC_DATAGRID1, m_Datagrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpecialityMan, CDialog)
	//{{AFX_MSG_MAP(CSpecialityMan)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree1)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_MODI_BUTTON, OnModiButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpecialityMan message handlers

BOOL CSpecialityMan::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Ȩ޿ƣǹԱӡ޸ĺɾťû
	if (curUser.UserType != 1)
	{
		GetDlgItem(IDC_ADD_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MODI_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEL_BUTTON)->EnableWindow(FALSE);
	}

	//װԺϵϢ
	dep.LoadDep();

	//Ӹڵ
	m_treeImageList.Create(16,16,FALSE,1,0);  //CImageListؼ
	//װICONԴ
	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON1));
	m_treeImageList.Add(hIcon);  //ICONԴӵCImageListؼ
	//CImageListؼTreeؼ	
	m_tree.SetImageList(&m_treeImageList, LVSIL_NORMAL);
	m_root = m_tree.InsertItem("ԺϵϢ");  //Ӹڵ
	//AddtoTree() ԺϵϢӵTreeؼ	
	AddtoTree(m_root, 0);
	m_tree.Expand(m_root, TVE_EXPAND); //չڵ
	//ѡиڵ
	m_tree.SelectItem(m_root);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSpecialityMan::RefreshData()
{
	UpdateData(TRUE);

	//TreeؼжȡԺϵϢ
	int iDepId;
	HTREEITEM node;
	node = m_tree.GetSelectedItem();
	iDepId = m_tree.GetItemData(node);

	//ԺϵSELECT
	CString cDepId;
	cDepId.Format("%d", iDepId);

	// SELECT
	CString cSource = "SELECT s.SpeId, s.Name AS רҵ, d.DepName AS Ժϵ,"
		" s.Describes AS  FROM Speciality s, DepInfo d"
		" WHERE s.DepId = d.DepId";

	// ѡĲǸڵ
	if(m_tree.GetItemData(node) != 0)		// Ǹڵ
	{
		// 2ڵ
		if(m_tree.GetItemData(m_tree.GetParentItem(node)) != 0)
		{
			cSource += " AND d.DepId = " + cDepId;
		}
		// 1ڵ
		else
		{
			cSource += " AND (d.UID = " + cDepId + " OR d.DepId = " + cDepId + ")";
		}
	}

	//ˢADO Dataؼļ¼Դ
	m_Adodc.SetRecordSource(cSource);
	m_Adodc.Refresh();
	
	//п
	_variant_t vIndex;
	vIndex = long(0);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(0);
	vIndex = long(1);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(2);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(2);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(100);
}

void CSpecialityMan::AddtoTree(HTREEITEM m_node, int UpperId)
{
	//ʹõݹ鷽ԺϵӵTreeViewؼ
	int i;
	HTREEITEM m_child;

	//ηdepеԺϵ飬ļ¼ӵTreeؼ
	for(i=0; i<dep.a_UID.GetSize(); i++)
	{
		//@@@@ a_UIDеUpperIdԪ
		//@@@@ ԪΪǰڵӽڵ㣬˽ӵTreeؼУ½ڵΪm_child
		//@@@@ ʹSetItemData()ԺϵֵҲ½ڵ
		//@@@@ ½ڵΪڵ㣬ٴεݹAddtoTree()ӽڵӵTreeؼ
		if (UpperId == atoi(dep.a_UID.GetAt(i)))
		{
			m_child = m_tree.InsertItem(dep.a_DepName.GetAt(i), m_node);
			m_tree.SetItemData(m_child, atol(dep.a_DepId.GetAt(i)));
			AddtoTree(m_child, atoi(dep.a_DepId.GetAt(i)));
		}
	}
}

// ѡԺϵ
void CSpecialityMan::OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	RefreshData();

	*pResult = 0;
}

// Ӱť
void CSpecialityMan::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	HTREEITEM node;  // ڱ浱ǰڵ
	node = m_tree.GetSelectedItem(); //ȡõǰڵֵ
	int iDepId;
	iDepId = m_tree.GetItemData(node);
	if (iDepId == 0)  // ڸڵרҵ
	{
		MessageBox("ѡԺϵ");
		return;
	}
	// ϵλרҵϢ
	if(iDepId != 0)		// Ǹڵ
		if(m_tree.GetItemData(m_tree.GetParentItem(node)) == 0)
		{
			MessageBox("ӦϵλרҵϢ");
			return;
		}

	CSpecialEditDlg dlg;
	// ʼ
	dlg.SpeId = 0;			// רҵΪ0ʾ
	dlg.DepId = iDepId;		// Ժϵ
	dlg.m_dep = m_tree.GetItemText(node);
	dlg.m_name = "";
	dlg.m_describe = "";

	if (dlg.DoModal() == IDOK)
		RefreshData();
}

// ޸İť
void CSpecialityMan::OnModiButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_Adodc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪ޸ĵļ¼!");
		return;
	}

	// ȡѡרҵļ¼
	CSpeciality cur;
	cur.GetInfo(m_Datagrid.GetItem(0));

	// רҵݶȡ༭Ի
	CSpecialEditDlg dlg;
	dlg.SpeId = cur.SpeId;
	dlg.Name = cur.Name;
	dlg.DepId = cur.DepId;
	dlg.m_dep = m_Datagrid.GetItem(2);
	dlg.m_name = cur.Name;
	dlg.m_describe = cur.Describes;

	if (dlg.DoModal() == IDOK)
		RefreshData();
}
// ɾť
void CSpecialityMan::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	if (m_Adodc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪɾļ¼!");
		return;
	}

	//ȡѡרҵļ¼
	if (MessageBox("Ƿɾǰ¼","ȷ", MB_YESNO) == IDYES)
	{
		CSpeciality cur;
		if(cur.HaveStu(m_Datagrid.GetItem(0)) == 1)
		{
			MessageBox("רҵѧɾ!");
			return;
		}
		cur.SqlDelete(m_Datagrid.GetItem(0));
		RefreshData();
	}
}
