// StuEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "StuEditDlg.h"
#include "Student.h"
#include "ADOConn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUserInfo curUser;

/////////////////////////////////////////////////////////////////////////////
// CStuEditDlg dialog


CStuEditDlg::CStuEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStuEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStuEditDlg)
	m_name = _T("");
	m_StuNum = _T("");
	//}}AFX_DATA_INIT
}


void CStuEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStuEditDlg)
	DDX_Control(pDX, IDC_SPECIALITY_COMBO, m_speciality);
	DDX_Control(pDX, IDC_SEX_COMBO, m_sex);
	DDX_Text(pDX, IDC_NAME_EDIT, m_name);
	DDX_Text(pDX, IDC_STU_NUM, m_StuNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStuEditDlg, CDialog)
	//{{AFX_MSG_MAP(CStuEditDlg)
	ON_CBN_SELCHANGE(IDC_SPECIALITY_COMBO, OnSelchangeSpecialityCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStuEditDlg message handlers

BOOL CStuEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(cStuId == "")
	{
		m_speciality.AddString("==רҵϢ==");
		spe.LoadSpe();

		for(int i=0; i<spe.a_SpeId.GetSize(); i++)
		{
			if (atol(spe.a_DepId.GetAt(i)) == DepId)
			{
				m_speciality.AddString(spe.a_Name.GetAt(i));
			}
		}
	}
	else
	{
		GetDlgItem(IDC_SPECIALITY_COMBO)->EnableWindow(FALSE);
		m_speciality.AddString(cSpe);
	}
	m_speciality.SetCurSel(0);

	//Ա
	if (cSex == "")
		m_sex.SetCurSel(0);
	else
		m_sex.SetCurSel(1);

	if (cStuId != "")  //ʾ޸
		GetDlgItem(IDC_STU_NUM)->EnableWindow(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CStuEditDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	// Чж
	if(m_StuNum == "")
	{
		MessageBox("ѧѧ");
		return;
	}
	if(m_name == "")
	{
		MessageBox("ѧ");
		return;
	}
	if(cStuId == "")
	{
		if(m_speciality.GetCurSel() == 0)
		{
			MessageBox("ѡרҵ");
			return;
		}
	}
	//ûݸֵcurУΪݿ׼
	CStudent cur;
	cur.iStuNum = atol(m_StuNum);
	cur.strName = m_name;
	if (m_sex.GetCurSel() == 0)
		cur.strSex = "";
	else
		cur.strSex = "Ů";
	cur.iDepId = DepId;
	cur.iSpeId = SpeId;
	
	cur.iBorrowBookCount = 0;
	//Զ˺ʱ
	if (cStuId == "")  //ʾ
		cur.SqlInsert();
	else
		cur.SqlUpdate(m_StuNum);//*/

	CDialog::OnOK();
}

void CStuEditDlg::OnSelchangeSpecialityCombo() 
{
	// TODO: Add your control notification handler code here
	// õǰרҵ
	CString strCurSpe;
	m_speciality.GetLBText(m_speciality.GetCurSel(), strCurSpe);

	// õSpeIdֵ
	for(int i = 0 ; i < spe.a_SpeId.GetSize(); i++)
	{
		if(spe.a_Name.GetAt(i) == strCurSpe)
		{
			SpeId = atol(spe.a_SpeId.GetAt(i));
		}
	}
}

