// UserManDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "UserManDlg.h"
#include "UserEditDlg.h"
#include "UserInfo.h"
#include "COMDEF.H"
#include "Columns.h"
#include "Column.h"
#include "_Recordset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUserManDlg dialog


CUserManDlg::CUserManDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserManDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserManDlg)
	//}}AFX_DATA_INIT
}


void CUserManDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserManDlg)
	DDX_Control(pDX, IDC_ADODC1, m_Adodc);
	DDX_Control(pDX, IDC_DATAGRID1, m_Datagrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserManDlg, CDialog)
	//{{AFX_MSG_MAP(CUserManDlg)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_MODI_BUTTON, OnModiButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserManDlg message handlers

BOOL CUserManDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	RefreshData();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


// 
void CUserManDlg::RefreshData()
{
	UpdateData(TRUE);
	
	// Select
	CString cSource = "SELECT UserName AS û, Passwd,"
		" CASE WHEN UserType=1 THEN 'ϵͳԱ' ELSE 'ͨû' END AS û"
		" FROM UserInfo";

	//ˢADO Dataؼļ¼Դ
	m_Adodc.SetRecordSource(cSource);
	m_Adodc.Refresh();
	
	//п
	_variant_t vIndex;
	vIndex = long(0);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(100);
	vIndex = long(1);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(0);
	vIndex = long(2);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(100);
}

// Ӱť
void CUserManDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	// ʼUserEditDlgԻеı
	CUserEditDlg dlg;
	dlg.cId = "";
	dlg.m_user = "";
	dlg.m_passwd = "";
	dlg.m_confirm = "";

	// UserEditDlgԻ
	if (dlg.DoModal() == IDOK)
		RefreshData();
}

// ޸İť
void CUserManDlg::OnModiButton() 
{
	// TODO: Add your control notification handler code here
	if (m_Adodc.GetRecordset().GetEof()) 
	{
		MessageBox("ѡҪ޸ĵļ¼");
		return;
	}
	
	// UserEditDlgԻеı
	CUserEditDlg dlg;
	dlg.cId = m_Datagrid.GetItem(0);
	dlg.m_user = m_Datagrid.GetItem(0);
	dlg.m_passwd = m_Datagrid.GetItem(1);
	dlg.m_confirm = m_Datagrid.GetItem(1);
	dlg.cType = m_Datagrid.GetItem(2);

	// UserEditDlgԻ
	if (dlg.DoModal() == IDOK)
		RefreshData();
	
}

// ɾť
void CUserManDlg::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	if (m_Adodc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪɾļ¼!");
		return;
	}

	// жǷΪĬû
	if(m_Datagrid.GetItem(0) == "admin")
	{
		MessageBox("ûΪĬûɾ!");
		return;
	}

	if (MessageBox("Ƿɾǰ¼","ȷ", MB_YESNO + MB_ICONQUESTION) == IDYES)
	{
		// ɾ
		CUserInfo cur;
		cur.SqlDelete(m_Datagrid.GetItem(0));
		RefreshData();
	}
}
