// BookEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BookEditDlg.h"
#include "BookInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBookEditDlg dialog


CBookEditDlg::CBookEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBookEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBookEditDlg)
	m_Author = _T("");
	m_BookCode = _T("");
	m_BookCount = _T("");
	m_Name = _T("");
	m_PublishYear = _T("");
	m_Publisher = _T("");
	m_RemainCount = _T("");
	//}}AFX_DATA_INIT
}


void CBookEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBookEditDlg)
	DDX_Text(pDX, IDC_EDIT_AUTHOR, m_Author);
	DDX_Text(pDX, IDC_EDIT_BOOK_CODE, m_BookCode);
	DDX_Text(pDX, IDC_EDIT_BOOK_COUNT, m_BookCount);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDX_Text(pDX, IDC_EDIT_PUBLISH_YEAR, m_PublishYear);
	DDX_Text(pDX, IDC_EDIT_PUBLISHER, m_Publisher);
	DDX_Text(pDX, IDC_EDIT_REMAIN_COUNT, m_RemainCount);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBookEditDlg, CDialog)
	//{{AFX_MSG_MAP(CBookEditDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBookEditDlg message handlers

void CBookEditDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if(m_BookCode == "")
	{
		MessageBox("ͼ벻Ϊգ!");
		return;
	}
	if(m_Name == "")
	{
		MessageBox("ͼƲΪգ!");
		return;
	}
	if(m_Author == "")
	{
		MessageBox("ͼƲΪգ!");
		return;
	}
	if(m_Publisher == "")
	{
		MessageBox("ͼƲΪգ!");
		return;
	}
	if(m_PublishYear == "")
	{
		MessageBox("ͼݲΪգ!");
		return;
	}
	if(m_BookCount == "")
	{
		MessageBox("ͼΪգ!");
		return;
	}
	CBookInfo BookInfo;
	BookInfo.iBookCode = atol(m_BookCode);
	BookInfo.strName = m_Name;
    BookInfo.strAuthor = m_Author;
	BookInfo.strPublisher = m_Publisher;
	BookInfo.iPublishYear = atol(m_PublishYear);
	BookInfo.iBookCount = atol(m_BookCount);
	BookInfo.iRemainCount = atol(m_RemainCount);
	if(FALSE == bFlag)
	{
		BookInfo.SqlInsert();
	}
	else
	{
		BookInfo.SqlUpdate(m_BookCode);
	}
	CDialog::OnOK();
}

BOOL CBookEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	bFlag = FALSE;//
	if(m_BookCode != "")
	{
		GetDlgItem(IDC_EDIT_BOOK_CODE)->EnableWindow(FALSE);
		bFlag = TRUE;//޸
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
