// BookManDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "BookManDlg.h"
#include "COMDEF.H"
#include "Columns.h"
#include "Column.h"
#include "_Recordset.h"
#include "BookInfo.h"
#include "BookEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBookManDlg dialog
extern CUserInfo curUser;

CBookManDlg::CBookManDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBookManDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBookManDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBookManDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBookManDlg)
	DDX_Control(pDX, IDC_ADODC1, m_ADOdc);
	DDX_Control(pDX, IDC_DATAGRID1, m_DataGrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBookManDlg, CDialog)
	//{{AFX_MSG_MAP(CBookManDlg)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	ON_BN_CLICKED(IDC_MODI_BUTTON, OnModiButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBookManDlg message handlers
BOOL CBookManDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Ȩ޿ƣǹԱӡ޸ĺɾťû
	if (curUser.UserType != 1)
	{
		GetDlgItem(IDC_ADD_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MODI_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEL_BUTTON)->EnableWindow(FALSE);
	}
	RefreshData();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CBookManDlg::RefreshData()
{
	// SELECT
	CString cSource = "SELECT b.BookCode AS ͼ, b.Name AS ͼ, b.Author AS ͼ,"
		"b.Publisher AS , b.PublishYear AS , b.BookCount AS ͼ, b.RemainCount AS ʣ"
		" FROM BookInfo AS b";

	//ˢADO Dataؼļ¼Դ
	m_ADOdc.SetRecordSource(cSource);
	m_ADOdc.Refresh();
	
	//п
	_variant_t vIndex;
	vIndex = long(0);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(55);
	vIndex = long(1);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(100);
	vIndex = long(2);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(50);
	vIndex = long(3);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(100);
	vIndex = long(4);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(50);
	vIndex = long(5);
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(45);
	vIndex = long(6);  //֤
	m_DataGrid.GetColumns().GetItem(vIndex).SetWidth(45);
}
//
void CBookManDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	CBookEditDlg dlg;
	// ʼ
	dlg.m_BookCode = "";		
	dlg.m_Name = "";		
	dlg.m_Author = "";			
	dlg.m_Publisher = "";	
	dlg.m_PublishYear = "2008";
	dlg.m_BookCount = "30";
	dlg.m_RemainCount = "30";
	//
	if (dlg.DoModal() == IDOK)
		RefreshData();
}
//ɾ
void CBookManDlg::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	if (m_ADOdc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪɾļ¼!");
		return;
	}

	//ȡѡѧļ¼
	if (MessageBox("Ƿɾǰ¼","ȷ", MB_YESNO) == IDYES)
	{
		CBookInfo cur;
		cur.SqlDelete(m_DataGrid.GetItem(0));
		RefreshData();
	}	
}
//޸
void CBookManDlg::OnModiButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_ADOdc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪ޸ĵļ¼!");
		return;
	}

	// ȡѡѧļ¼
	CBookInfo cur;
	cur.GetInfo(m_DataGrid.GetItem(0));

	// ѧݶȡ༭Ի
	CBookEditDlg dlg;
	dlg.m_BookCode = m_DataGrid.GetItem(0);		
	dlg.m_Name = m_DataGrid.GetItem(1);		
	dlg.m_Author = m_DataGrid.GetItem(2);			
	dlg.m_Publisher = m_DataGrid.GetItem(3);	
	dlg.m_PublishYear = m_DataGrid.GetItem(4);
	dlg.m_BookCount = m_DataGrid.GetItem(5);
	dlg.m_RemainCount = m_DataGrid.GetItem(6);

	if (dlg.DoModal() == IDOK)
		RefreshData();
}
