// RestorBookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "RestorBookDlg.h"
#include "BookInfo.h"
#include "Student.h"
#include "BorrowBookInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRestorBookDlg dialog


CRestorBookDlg::CRestorBookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRestorBookDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRestorBookDlg)
	m_BookCode = _T("");
	m_StuNum = _T("");
	//}}AFX_DATA_INIT
}


void CRestorBookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRestorBookDlg)
	DDX_Text(pDX, IDC_EDIT_BOOK_CODE, m_BookCode);
	DDX_Text(pDX, IDC_EDIT_STU_NUM, m_StuNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRestorBookDlg, CDialog)
	//{{AFX_MSG_MAP(CRestorBookDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRestorBookDlg message handlers

void CRestorBookDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if(m_BookCode == "")
	{
		MessageBox("ͼΪգ");
		return;
	}
	if(m_StuNum == "")
	{
		MessageBox("ѧѧΪգ");
		return;
	}
	//-----------------------
	CBookInfo BI;
	//BI.iBookCode = atol(m_BookCode);
	if(BI.GetName(m_BookCode) == "")
	{
		MessageBox("ͼ鲻, ȷͼǷȷ!");
		return;
	}

	CStudent st;
	//st.iStuNum = atol(m_StuNum);
	if(st.GetName(m_StuNum) == "")
	{
		MessageBox("ѧڣȷѧǷȷ!");
		return;
	}
	//-----------------------
	CBorrowBookInfo BBI;
	int iBorrowID = BBI.GetBorrowId(m_BookCode, m_StuNum);
	if(iBorrowID == -1)
	{
		MessageBox("ѧûн飬ȷǷȷ!");
		return;
	}
	if(IDOK != MessageBox("ȷʵҪע¼?", "Ϣȷ", MB_OKCANCEL))
	{
		return;
	}

	CString str;
	str.Format("%ld", iBorrowID);
	BBI.SqlDelete(str);
	//---------------------
	BI.GetInfo(m_BookCode);
	BI.iRemainCount++;
	BI.SqlUpdate(m_BookCode);

	st.GetInfo(m_StuNum);
	st.iBorrowBookCount--;
	st.SqlUpdate(m_StuNum);
	//---------------------
	CDialog::OnOK();
}
