// StuManDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "StuManDlg.h"
#include "StuEditDlg.h"
#include "Student.h"
#include "DepInfo.h"
#include "UserInfo.h"
#include "COMDEF.H"
#include "Columns.h"
#include "Column.h"
#include "_Recordset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUserInfo curUser;

/////////////////////////////////////////////////////////////////////////////
// CStuManDlg dialog


CStuManDlg::CStuManDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStuManDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStuManDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CStuManDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStuManDlg)
	DDX_Control(pDX, IDC_TREE1, m_tree);
	DDX_Control(pDX, IDC_ADODC1, m_Adodc);
	DDX_Control(pDX, IDC_DATAGRID1, m_Datagrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStuManDlg, CDialog)
	//{{AFX_MSG_MAP(CStuManDlg)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree1)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_MODI_BUTTON, OnModiButton)
	ON_BN_CLICKED(IDC_DEL_BUTTON, OnDelButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStuManDlg message handlers

BOOL CStuManDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Ȩ޿ƣǹԱӡ޸ĺɾťû
	if (curUser.UserType != 1)
	{
		GetDlgItem(IDC_ADD_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MODI_BUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEL_BUTTON)->EnableWindow(FALSE);
	}

	//װԺϵϢ
	dep.LoadDep();

	//Ӹڵ
	m_treeImageList.Create(16,16,FALSE,1,0);  //CImageListؼ
	//װICONԴ
	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON1));
	m_treeImageList.Add(hIcon);  //ICONԴӵCImageListؼ
	//CImageListؼTreeؼ	
	m_tree.SetImageList(&m_treeImageList, LVSIL_NORMAL);
	m_root = m_tree.InsertItem("ԺϵϢ");  //Ӹڵ
	//AddtoTree() ԺϵϢӵTreeؼ	
	AddtoTree(m_root, 0);
	m_tree.Expand(m_root, TVE_EXPAND); //չڵ
	//ѡиڵ
	m_tree.SelectItem(m_root);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStuManDlg::RefreshData()
{
	UpdateData(TRUE);

	//TreeؼжȡԺϵϢ
	int iDepId;
	HTREEITEM node;
	node = m_tree.GetSelectedItem();
	iDepId = m_tree.GetItemData(node);

	//ԺϵSELECT
	CString cDepId;
	cDepId.Format("%d", iDepId);

	// SELECT
	CString cSource = "SELECT s.StuId, s.Name AS , s.Sex AS Ա, p.Name AS רҵ,"
		"s.BorrowBookCount AS ,  "
		"s.DepId,s.SpeId"
		" FROM Student s, Speciality p, DepInfo d WHERE s.DepId = d.DepId AND s.SpeId = p.SpeId";

	// ѡĲǸڵ
	if(m_tree.GetItemData(node) != 0)		// Ǹڵ
	{
		// 2ڵ
		if(m_tree.GetItemData(m_tree.GetParentItem(node)) != 0)
		{
			cSource += " AND d.DepId = " + cDepId;
		}
		// 1ڵ
		else
		{
			cSource += " AND (d.UID = " + cDepId + " OR d.DepId = " + cDepId + ")";
		}
	}

	//ˢADO Dataؼļ¼Դ
	m_Adodc.SetRecordSource(cSource);
	m_Adodc.Refresh();
	
	//п
	_variant_t vIndex;
	vIndex = long(0);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(50);
	vIndex = long(1);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(2);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(30);
	vIndex = long(3);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(70);
	vIndex = long(4);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(60);
	vIndex = long(5);
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(0);
	vIndex = long(6);  //֤
	m_Datagrid.GetColumns().GetItem(vIndex).SetWidth(0);
}

void CStuManDlg::AddtoTree(HTREEITEM m_node, int UpperId)
{
	//ʹõݹ鷽ԺϵӵTreeViewؼ
	int i;
	HTREEITEM m_child;

	//ηdepеԺϵ飬ļ¼ӵTreeؼ
	for(i=0; i<dep.a_UID.GetSize(); i++)
	{
		//@@@@ a_UIDеUpperIdԪ
		//@@@@ ԪΪǰڵӽڵ㣬˽ӵTreeؼУ½ڵΪm_child
		//@@@@ ʹSetItemData()ԺϵֵҲ½ڵ
		//@@@@ ½ڵΪڵ㣬ٴεݹAddtoTree()ӽڵӵTreeؼ
		if (UpperId == atoi(dep.a_UID.GetAt(i)))
		{
			m_child = m_tree.InsertItem(dep.a_DepName.GetAt(i), m_node);
			m_tree.SetItemData(m_child, atol(dep.a_DepId.GetAt(i)));
			AddtoTree(m_child, atoi(dep.a_DepId.GetAt(i)));
		}
	}
}

// ѡԺϵ
void CStuManDlg::OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	RefreshData();

	*pResult = 0;
}

// Ӱť
void CStuManDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	HTREEITEM node;  // ڱ浱ǰڵ
	node = m_tree.GetSelectedItem(); //ȡõǰڵֵ
	int iDepId;
	iDepId = m_tree.GetItemData(node);
	if (iDepId == 0)  // ڸڵѧ
	{
		MessageBox("ѡԺϵ");
		return;
	}
	// ϵλѧϢ
	if(iDepId != 0)		// Ǹڵ
	{
		if(m_tree.GetItemData(m_tree.GetParentItem(node)) == 0)
		{
			MessageBox("ӦϵλѧϢ");
			return;
		}
	}
	
	CStuEditDlg dlg;
	// ʼ
	dlg.cStuId = "";		// ѧΪ""ʾ
	dlg.DepId = iDepId;		// Ժϵ
	dlg.SpeId = 0;			// רҵϢ
	dlg.cSex = "";		// ԱʼΪ
	// Ϊ
	if (dlg.DoModal() == IDOK)
		RefreshData();//*/
}

// ޸İť
void CStuManDlg::OnModiButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
//*
	if (m_Adodc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪ޸ĵļ¼!");
		return;
	}

	// ȡѡѧļ¼
	CStudent cur;
	cur.GetInfo(m_Datagrid.GetItem(0));

	// ѧݶȡ༭Ի
	CStuEditDlg dlg;
	dlg.cStuId = m_Datagrid.GetItem(0);
	dlg.m_StuNum = m_Datagrid.GetItem(0);
	dlg.Name = m_Datagrid.GetItem(1);
	dlg.DepId = atol(m_Datagrid.GetItem(5));
	dlg.SpeId = atol(m_Datagrid.GetItem(6));

	dlg.m_name = m_Datagrid.GetItem(1);
	dlg.cSex = m_Datagrid.GetItem(2);
	dlg.cSpe = m_Datagrid.GetItem(3);

	if (dlg.DoModal() == IDOK)
		RefreshData();//*/
}

// ɾť
void CStuManDlg::OnDelButton() 
{
	// TODO: Add your control notification handler code here
	if (m_Adodc.GetRecordset().GetEof())
	{
		MessageBox("ѡҪɾļ¼!");
		return;
	}

	//ȡѡѧļ¼
	if (MessageBox("Ƿɾǰ¼","ȷ", MB_YESNO) == IDYES)
	{
		CStudent cur;
		cur.SqlDelete(m_Datagrid.GetItem(0));
		RefreshData();
	}	
}