// Student.cpp: implementation of the CStudent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "Student.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStudent::CStudent()
{
    iStuNum = 0;
	strName = "";
	strSex = "";
	iDepId = 0;
	iSpeId = 0;
	iBorrowBookCount = 0;
}

CStudent::~CStudent()
{

}

// ѧŵõϢ
void CStudent::GetInfo(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT * FROM Student WHERE StuId = " + paraId;

	//ִSELETE
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);

	//ظеֵ
	if (m_pRecordset->adoEOF)
		CStudent();
	else
	{
		iStuNum = atol(paraId);
		strName = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name");
		strSex = (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Sex");
		iDepId = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("DepId"));

		iSpeId = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("SpeId"));		
		iBorrowBookCount = atol((LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("BorrowBookCount"));
	}

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

//ȡָѧ
CString CStudent::GetName(CString paraId)
{	
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//SELECT
	_bstr_t vSQL;
	vSQL = "SELECT Name FROM Student WHERE StuId = " + paraId;

	//ִSELECT
	_RecordsetPtr m_pRecordset;
	m_pRecordset = m_AdoConn.GetRecordSet(vSQL);
	if (m_pRecordset->adoEOF)
		return "";
	else
		return (LPCTSTR)(_bstr_t)m_pRecordset->GetCollect("Name");

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// 
void CStudent::SqlInsert()
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//INSERT
	CString strStuNum;
	strStuNum.Format("%ld", iStuNum);
	CString strDepId;
	strDepId.Format("%ld", iDepId);
	CString strSpeId;
	strSpeId.Format("%ld", iSpeId);
	CString strBorrowBookCount;
	strBorrowBookCount.Format("%ld", iBorrowBookCount);
	_bstr_t vSQL;
	
    vSQL = "INSERT INTO Student (StuId, Name, Sex, DepId, SpeId, BorrowBookCount)"
		" VALUES ('" + strStuNum + "', '" + strName + "', '" + strSex + "', '" + strDepId
		+ "', '" + strSpeId + "', '" + strBorrowBookCount + "')";
	//ִINSERT
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ޸Ĳ
void CStudent::SqlUpdate(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//UPDATE
	_bstr_t vSQL;
	
	CString strDepId;
	strDepId.Format("%ld", iDepId);
	CString strSpeId;
	strSpeId.Format("%ld", iSpeId);
	CString strBorrowBookCount;
	strBorrowBookCount.Format("%ld", iBorrowBookCount);
	vSQL = "UPDATE Student SET Name = '" + strName + "', Sex = '" + strSex
		+ "', DepId = '" + strDepId + "', SpeId = '" + strSpeId + "', BorrowBookCount = '" + strBorrowBookCount
		+ "' WHERE StuId = " + paraId;

	//ִUPDATE
	m_AdoConn.ExecuteSQL(vSQL);

	//Ͽݿ
	m_AdoConn.ExitConnect();
}

// ɾָѧϢ
void CStudent::SqlDelete(CString paraId)
{
	//ݿ
	ADOConn m_AdoConn;
	m_AdoConn.OnInitADOConn();

	//DELETE
	_bstr_t vSQL;
	vSQL = "DELETE FROM Student WHERE StuId = " + paraId;

	//ִDELETE
	m_AdoConn.ExecuteSQL(vSQL);	

	//Ͽݿ
	m_AdoConn.ExitConnect();
}//*/