// UserEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibraryMagSys.h"
#include "UserEditDlg.h"
#include "UserInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUserEditDlg dialog


CUserEditDlg::CUserEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserEditDlg)
	m_user = _T("");
	m_confirm = _T("");
	m_passwd = _T("");
	//}}AFX_DATA_INIT
}


void CUserEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserEditDlg)
	DDX_Control(pDX, IDC_TYPE_COMBO, m_type);
	DDX_Text(pDX, IDC_USER_EDIT, m_user);
	DDX_Text(pDX, IDC_CONFIRM_EDIT, m_confirm);
	DDX_Text(pDX, IDC_PASSWD_EDIT, m_passwd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserEditDlg, CDialog)
	//{{AFX_MSG_MAP(CUserEditDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserEditDlg message handlers

BOOL CUserEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(cId == "")
	{
		m_type.SetCurSel(1);
	}
	else
	{
		GetDlgItem(IDC_USER_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PASSWD_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_CONFIRM_EDIT)->EnableWindow(FALSE);
		if(cType == "ϵͳԱ")
			m_type.SetCurSel(0);
		else
			m_type.SetCurSel(1);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

// ȷť
void CUserEditDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	
	CUserInfo cur;
	// ûЧԲ
	if(cId == "")
	{
		// һ
		if(m_passwd != m_confirm)
		{
			MessageBox("ȷǷȷ");
			m_passwd = "";
			m_confirm = "";
			UpdateData(FALSE);
			GetDlgItem(IDC_PASSWD_EDIT)->SetFocus();
			return;
		}
		// ûΪ
		if(m_user == "")
		{
			MessageBox("û");
			GetDlgItem(IDC_USER_EDIT)->SetFocus();
			return;
		}
		// ûǷ
		if(cur.IsExistUser(m_user))
		{
			MessageBox("ûѾڣע");
			m_user = "";
			UpdateData(FALSE);
			GetDlgItem(IDC_USER_EDIT)->SetFocus();
			return;
		}
	}
	else
	{
		if(m_user == "admin")
		{
			MessageBox("ûΪĬû޸");
			m_user = "";
			UpdateData(FALSE);
			GetDlgItem(IDC_USER_EDIT)->SetFocus();
			return;
		}
	}
	
	// curֵ
	cur.UserName = m_user;
	cur.Passwd = m_passwd;
	cur.UserType = m_type.GetCurSel() + 1;
	
	// 
	if(cId == "")
	{
		cur.SqlInsert();
	}
	else
	{
		cur.SqlUpdate(m_user);
	}
	
	CDialog::OnOK();
}